#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

unsigned int good_canary;

unsigned int canary_init() {
    unsigned char r;
    int rfd = open("/dev/random", O_RDONLY);
    good_canary = 0xDEADBEEF;
    good_canary &= ~0x00FF0000;
    read(rfd, &r, 1);
    good_canary = good_canary | (r << 16);
    return good_canary;
}

void canary_check(unsigned int current) {
    if (current != good_canary) {
        printf("Stack smaching detected: %p vs. %p\n",
               (void*)current, (void*)good_canary);
        exit(1);
    }
    puts("Canary OK!");
}

void bad_func() {
    puts("Missile launched!");
}

void func() {
    unsigned int canary = canary_init();
    char name[100];
    gets(name);
    canary_check(canary);
}

int main() {
    func();
    return 0;
}
